#include <stdio.h>
#include <stdlib.h>
#include <sys/times.h>
#include <unistd.h>

#define BUFFSIZE 384

int
main(int argc, char *argv[])
{
  int i, im, seek=0, speed=1, draw_on=0;
  double x, y;
  double data[BUFFSIZE][2]={{0,0}};
  FILE *GPLT;

  if (argc > 1 ) speed = atoi(argv[1]);

  GPLT = popen("gnuplot -geometry 400x300","w");
  setlinebuf(GPLT);
  fprintf(GPLT, 
    "set noxtics\n"
    "set yrange[-5:5]\n"
    "set nokey\n");

  while(1){
    fscanf(stdin,"%lf %lf", &x, &y);
    seek %= BUFFSIZE;
    data[seek][0]=x;
    data[seek][1]=y;

    if ( 0 == (draw_on++ % speed) )  {
      fprintf(GPLT, "plot '-' w l lt 1 lw 2\n");
      for (i = 1; i < BUFFSIZE; i++){
        im = (i + seek) % BUFFSIZE;
        fprintf(GPLT, "%f %f\n",data[im][0],data[im][1]);
      }
      fprintf(GPLT,"e\n");
    }
    seek++;
  }
  fclose(GPLT);

  return 0;
}
